#lang racket/base
(require "global.rkt"
         "mem.rkt"
         "pc.rkt"
         "nums.rkt"
         "instructions.rkt")

(provide run
         decode
         execute)

;; run : -> void
(define (run)
  (let ((the-value (get-mem (get&inc-pc))))
    (execute (sign the-value) (decode the-value))
    (run)))

;; decode : num -> (vector digit)
(define (decode num)
  (build-vector DIGITS (lambda (i) (extract num i 1))))

;; execute : instruction
(define execute
  (dispatch-to ImmediateInstructions 0))

